/*
   2021 Microside Technology

   Microside Technology no se hace responsable del uso que se haga a
   este código; para uso industrial, educativo o cualquier otro enfoque.
   No se brinda soporte técnico relacionado con este código.
*/

//es necesario que XNC01 se encuentre en modo maestro
int ledPin = 12;
void setup() {
  //LED incluido en la tarjeta
  pinMode(ledPin, OUTPUT);
  //configura serial (PC) a 115200
  Serial.begin(115200);
  //configura serial (Nodos) a 115200
  Serial2.begin(115200);
}


int ledState = LOW;             // estado para setear el LED
unsigned long previousMillis = 0;        // guardara la última vez del Blink
unsigned long previousMillis_res = 0;        // guardara la última vez del Blink
const long interval = 100;           // intervalo para el blink
int cont_flag = 0;
int cont_flag_res = 0;

void loop() {
  //si llega algun dato desde los nodos lo retransmite a PC
  if (Serial2.available() > 0) {
    char c = Serial2.read();
    if (c == 'X' || c == 'O' || cont_flag_res != 0) {
      Serial.write(c);
      cont_flag_res = 2;
      cont_flag = 4;
    }
  }
  //si llega algun dato desde PC lo retransmite a los nodod
  if (Serial.available() > 0) {
    Serial2.write(Serial.read());
    //blink 4 veces
    cont_flag = 4;
  }

  unsigned long currentMillis = millis();
  if ((currentMillis - previousMillis >= interval) &&  cont_flag != 0) {
    // guarda la última vez que hiciste blink LED
    previousMillis = currentMillis;
    cont_flag--;
    if (ledState == LOW) {
      ledState = HIGH;
    } else {
      ledState = LOW;
    }
    digitalWrite(ledPin, ledState);
  }
  else if (cont_flag == 0)
    digitalWrite(ledPin, HIGH);


  currentMillis = millis();
  if ((currentMillis - previousMillis_res >= interval) &&  cont_flag_res != 0) {
    previousMillis_res = currentMillis;
    cont_flag_res--;
  }
}
